var _excluded = ["portal", "separator", "type", "min", "max", "disabledStart", "disabledEnd", "allowClear", "value", "onChange"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useEffect, useImperativeHandle, useState } from 'react';
import MultipleMain from "./../MultipleMain";

// 内库使用-start
import LocaleUtil from "../../../utils/LocaleUtil";
// 内库使用-end

/* 测试使用-start
import { LocaleUtil } from 'seedsui-react'
测试使用-end */

// 日期区间弹窗
var PickerMain = function PickerMain(_ref, ref) {
  var portal = _ref.portal,
    separator = _ref.separator,
    type = _ref.type,
    min = _ref.min,
    max = _ref.max,
    disabledStart = _ref.disabledStart,
    disabledEnd = _ref.disabledEnd,
    allowClear = _ref.allowClear,
    value = _ref.value,
    onChange = _ref.onChange,
    props = _objectWithoutProperties(_ref, _excluded);
  var mainRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      mainDOM: mainRef.current,
      getMainDOM: function getMainDOM() {
        return mainRef.current;
      },
      getValue: function getValue() {
        var _mainRef$current, _mainRef$current$getV;
        var multipleValue = mainRef === null || mainRef === void 0 || (_mainRef$current = mainRef.current) === null || _mainRef$current === void 0 || (_mainRef$current$getV = _mainRef$current.getValue) === null || _mainRef$current$getV === void 0 ? void 0 : _mainRef$current$getV.call(_mainRef$current);
        if (!multipleValue) {
          return null;
        }
        var newValue = [multipleValue === null || multipleValue === void 0 ? void 0 : multipleValue[0].value, multipleValue === null || multipleValue === void 0 ? void 0 : multipleValue[1].value];
        return newValue;
      }
    };
  });
  var _useState = useState(null),
    _useState2 = _slicedToArray(_useState, 2),
    multipleDate = _useState2[0],
    setMultipleDate = _useState2[1];
  useEffect(function () {
    var _ref2 = value || [null, null],
      _ref3 = _slicedToArray(_ref2, 2),
      startDate = _ref3[0],
      endDate = _ref3[1];
    setMultipleDate([{
      id: 'start',
      description: LocaleUtil.locale('开始时间', 'SeedsUI_start_time'),
      value: startDate
    }, {
      id: 'end',
      description: LocaleUtil.locale('结束时间', 'SeedsUI_end_time'),
      value: endDate
    }]);
  }, [value]); // eslint-disable-line

  function handleChange(newMultipleDate) {
    var newValue = [newMultipleDate[0].value, newMultipleDate[1].value];
    onChange && onChange(newValue);
  }

  // 未构建完成Tabs不渲染
  if (!multipleDate) {
    return null;
  }
  return /*#__PURE__*/React.createElement(MultipleMain, _extends({
    ref: mainRef,
    portal: portal,
    separator: separator,
    type: type,
    value: multipleDate.map(function (item) {
      if (item.id === 'start' && disabledStart) {
        item.disabled = true;
      } else if (item.id === 'end' && disabledEnd) {
        item.disabled = true;
      }
      return item;
    }),
    min: type === 'week' ? min : undefined,
    max: type === 'week' ? max : undefined,
    allowClear: allowClear,
    onChange: handleChange
  }, props));
};
export default /*#__PURE__*/forwardRef(PickerMain);